Bug 587349 - Various patches needed for gv I18N support
Various patches needed for gv I18N support
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Xaw3d (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Stepan Kasal
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 600926
  Show dependency treegraph
 
Reported: 2010-04-29 12:46 EDT by Orion Poplawski
Modified: 2010-11-25 20:05 EST (History)
4 users (show)

See Also:
Fixed In Version: Xaw3d-1.5E-18.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 697587 (view as bug list)
Environment:
Last Closed: 2010-11-25 20:05:03 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Orion Poplawski 2010-04-29 12:46:18 EDT
Description of problem:

The latest version of gv triggers some bugs in Xaw3d.  The README.I18N file in gv states:

NEED:
        Xaw3d 1.4, 1.5 has a fatal bug in MultiSrc.c line 735-740.
        This GV's patch need Xaw3d library patched follow:

*** xc/lib/Xaw3d/MultiSrc.c     Fri May 15 04:03:23 1998
--- xc-fix/lib/Xaw3d/MultiSrc.c Fri Dec 18 09:59:52 1998
@@ -736,6 +736,7 @@
   
   if ( string_set || (old_src->multi_src.type != src->multi_src.type) ) {
     RemoveOldStringOrFile(old_src, string_set);
+    src->multi_src.allocated_string = old_src->multi_src.allocated_string;
     file = InitStringOrFile(src, string_set);
 
     /* Load pieces does this logic for us, but it shouldn't.  Its messy.*/



Another bug in Xaw3d will segfault in closing the application. The following
patch will fix it:

--- XawIm.c
+++ XawIm.c
@@ -331,12 +331,12 @@ static void DestroyAllIM( ve )
     /*
      * Close Input Method
      */
-    CloseIM(ve);
     if (!XFindContext(XDisplayOfIM(ve->im.xim), (Window)ve->im.xim, errContext,
                      (XPointer*)&contextErrData)) {
        if (contextErrData) XtFree((char *)contextErrData);
     }
     XDeleteContext(XDisplayOfIM(ve->im.xim), (Window)ve->im.xim, errContext);
+    CloseIM(ve);
     ve->im.xim = NULL;
 
     /*


Also, a collection of Xaw3D 1.5E bug fixing patches can be found at:
http://gitorious.org/xaw3d
git://gitorious.org/xaw3d/xaw3d.git
Comment 1 Orion Poplawski 2010-04-29 12:48:17 EDT
From an email from the gv maintainer:

Without this bug fix, international mode is broken (it will segfault on exit with high probability). See the File README.I18N which is included on GNU gv for details. The missing bug fix is the 2nd patch of my README.I18N file.

BTW: The bug fix for Xaw3d is safe, OpenSuSE has been using it for several years now.

Thanks
Markus Steinborn
GNU gv maintainer

PS: The bug I mean is also present in Debian. Their bug report is at http://bugs.debian.org/573474
Comment 2 Bug Zapper 2010-11-03 12:02:23 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 M. Steinborn 2010-11-08 05:48:39 EST
Can somebody please increase the "Version" - this bug is present in newer fedora products, too - so it should not expire.

Thanks.
Comment 4 Hans de Goede 2010-11-08 07:29:55 EST
(In reply to comment #3)
> Can somebody please increase the "Version" - this bug is present in newer
> fedora products, too - so it should not expire.

Done, and I've also put looking into the suggested patches onto my to do list (not sure when I'll get around to it though).

Regards,

Hans
Comment 5 Orion Poplawski 2010-11-08 12:12:17 EST
Hans - I can add the patches to the package if you'd like.
Comment 6 Hans de Goede 2010-11-08 13:47:43 EST
(In reply to comment #5)
> Hans - I can add the patches to the package if you'd like.

Hi,

Thanks for the offer, that would be great! My plan was to look at:
http://gitorious.org/xaw3d

And cherry pick all patches that look safe (so likely / hopefully all). If you could prepare a package with all bugfixing patches from there in there for rawhide (and commit and build if you have the rights) that would be great!

Then I'll go over the patches and if nothing stands out go ahead and cherry pick your work to F14. If something does stand out as non safe, then I'll drop those and do a bug-fix update for F14 with only the patches I consider safe.

Regards,

Hans
Comment 7 Hans de Goede 2010-11-08 13:49:41 EST
p.s.

I don't know where Stepan stand wrt this, but from my pov another co-maintainer would certainly be welcome. So if you've a vested interested in Xaw3d, and Stepan is ok with it, feel free to apply for co-maintainer ship in pkgdb. Then you can  just go ahead and do bugfixes / updates as you see fit.
Comment 8 Orion Poplawski 2010-11-08 17:07:51 EST
Well, my only real interest in this is not having gv segfault on close.  I don't follow or know much about Xaw3d otherwise.

Added those that apply to rawhide.  -thumb, -cast, and -secure don't apply - apparently because they (or similar) have already been applied.  Looks like -lex is still in git but no longer applied.

http://koji.fedoraproject.org/koji/taskinfo?taskID=2588369

I will build gv against it shortly.
Comment 9 Hans de Goede 2010-11-08 17:55:55 EST
Hi,

Thanks! I've taken a look at the patches you did not apply, and the cast patch is a better fix (an actual fix rather then silencing the compiler complaining), and the -thumb fix apart for one small bit also contains fixes we don't have yet.
So I've taken the liberty of resolving the conflicts and doing another build
(also bumping the release which you forgot).

I've also re-enabled the -lex patch thanks for pointing that out.

So how do you want to move forward with this for F-13 and F-14? Do you want to
simple also build the same package as an update there (that is ok with me). Or would you prefer to only cherry pick the 2 relevant patches for the gv issues you are seeing there ?

Regards,

Hans
Comment 10 M. Steinborn 2010-11-09 07:05:09 EST
Tested with Xaw3d-1.5E-17.fc15.src.rpm from Koji, recompiled for RHEL/CentOS 5.5.

Well, Xaw3d-1.5E-lex.patch breaks linking GNU gv for me:

gcc  -g -O2   -o gv Aaa.o Aaa_bison.o Aaa_lex.o Button.o Clip.o FileSel.o Frame.o Ghostview.o MButton.o Switch.o Vlist.o actions.o callbacks.o confirm.o dialog.o doc_misc.o error.o file.o info.o magmenu.o main.o media.o misc.o miscmenu.o misc_private.o note.o options.o options_fs.o options_gs.o options_gv.o options_setup.o process.o popup.o ps.o resource.o save.o scale.o secscanf.o gv_signal.o version.o widgets_misc.o zoom.o Scrollbar.o   ../lib/libgnu.a -lXinerama -lXaw3d -lXpm -lXmu -lXt -lXext -lSM -lICE -lX11 -lfl -lm
/usr/lib/gcc/i386-redhat-linux/4.1.2/../../../libXaw3d.so: undefined reference to `LayYYsetsource'
/usr/lib/gcc/i386-redhat-linux/4.1.2/../../../libXaw3d.so: undefined reference to `LayYYerror'


Without this patch all is well.
Comment 11 Hans de Goede 2010-11-09 08:16:13 EST
(In reply to comment #10)
Thanks for testing!

> Well, Xaw3d-1.5E-lex.patch breaks linking GNU gv for me:

Oops, you're right. Dropped it and removed it from git, -18 with the -lex patch removed is now building.

Orion,

Do you want me to also push this as an update for F-14 and F-13 ?

Regards,

Hans
Comment 12 Orion Poplawski 2010-11-09 11:29:03 EST
I think F-14 would be nice, not so concerned about F-13.
Comment 13 Fedora Update System 2010-11-10 03:42:38 EST
Xaw3d-1.5E-18.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/Xaw3d-1.5E-18.fc14
Comment 14 Fedora Update System 2010-11-10 16:41:10 EST
Xaw3d-1.5E-18.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update Xaw3d'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/Xaw3d-1.5E-18.fc14
Comment 15 Fedora Update System 2010-11-25 20:04:57 EST
Xaw3d-1.5E-18.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.